package com.jkcredit.invoice.hub.service.apiCompany;

import cn.com.taiji.sdk.comm.ETCCommHelper;
import cn.com.taiji.sdk.model.comm.protocol.eoms.company.CompanyQueryRequest;
import cn.com.taiji.sdk.model.comm.protocol.eoms.company.CompanyQueryResponse;
import com.alibaba.fastjson.JSONObject;
import com.jkcredit.invoice.hub.enums.ApiResponseCodeEnum;
import com.jkcredit.invoice.hub.spi.rest.data.ApiResponseData;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.io.IOException;

/**
 * @description:
 * @author: xusonglin
 * @create: 2020/1/15 23:50
 * @version: V1.0
 **/
@Service
@Slf4j
public class ApiCompanyServiceImpl implements ApiCompanyService {
    @Override
    public ApiResponseData companyQuery(JSONObject param) {
        long costTimeStart = System.currentTimeMillis();
        String result;

        CompanyQueryRequest request = new CompanyQueryRequest();
        request.setCompanyName(param.get("companyName").toString().trim());
        request.setTaxpaterCode(param.get("taxplayerCode").toString().trim());
        String fileName = request.getFilename();

        try {
            // (4)指定协议的响应模型（IssuerUploadResponse），调用upload 发送数据
            CompanyQueryResponse response = ETCCommHelper.upload(fileName, request, CompanyQueryResponse.class);

            // (5)发送成功处理（这里为示例，简单的将响应模型转为json字符串输出，各省根据实际情况处理）
            result = response.toJson();
            long costTimeEnd = System.currentTimeMillis();
            log.info("[-companyQuery-] result is " + result.replaceAll("\r|\n", "") + " , request is "
                    + param + ",costtime=" + (costTimeEnd - costTimeStart) + ",startTime=" + costTimeStart
                    + ",endTime=" + costTimeEnd);
        } catch (IOException e) {
            // todo 失败返回码和信息
            log.info("[-companyQuery-] 网络异常 " + e);
            return ApiResponseData.failure(1, "");
        } catch (Exception apie) {
            // todo 失败返回码和信息
            log.info("[-companyQuery-] 错误信息：" + apie.getMessage());
            return ApiResponseData.failure(1, "");
        }
        return ApiResponseData.success(ApiResponseCodeEnum.CODE_200.getValue(), result);
    }
}
